<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
            <el-form-item label="性别" prop="gender">
                <el-select v-model="queryParams.gender" placeholder="请选择性别" clearable style="width: 186px;">
                    <el-option
                            v-for="dict in sys_user_sex"
                            :key="dict.value"
                            :label="dict.label"
                            :value="dict.value"
                    />
                </el-select>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
                <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button
                        type="primary"
                        plain
                        icon="Plus"
                        @click="handleAdd"
                        v-hasPermi="['xjc-platform:studentmanager:add']"
                >新增
                </el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button
                        type="success"
                        plain
                        icon="Edit"
                        :disabled="single"
                        @click="handleUpdate"
                        v-hasPermi="['xjc-platform:studentmanager:edit']"
                >修改
                </el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button
                        type="danger"
                        plain
                        icon="Delete"
                        :disabled="multiple"
                        @click="handleDelete"
                        v-hasPermi="['xjc-platform:studentmanager:remove']"
                >删除
                </el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button
                        type="warning"
                        plain
                        icon="Download"
                        @click="handleExport"
                        v-hasPermi="['xjc-platform:studentmanager:export']"
                >导出
                </el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="info" plain icon="Upload" @click="handleImport"
                           v-hasPermi="['xjc-platform:studentmanager:import']">导入
                </el-button>
            </el-col>
            <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="studentmanagerList" @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55" align="center"/>
            <el-table-column label="姓名 " align="center" prop="userName"/>
            <el-table-column label="账号 " align="center" prop="nickName"/>
            <el-table-column label="年级 " align="center" prop="gradeYear"/>
            <el-table-column label="班级 " align="center" prop="className"/>
            <el-table-column label="学校" align="center" prop="officeName"/>
            <el-table-column label="性别" align="center" prop="gender">
                <template #default="scope">
                    <dict-tag :options="sys_user_sex" :value="scope.row.gender"/>
                </template>
            </el-table-column>
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                <template #default="scope">
                    <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
                               v-hasPermi="['xjc-platform:studentmanager:edit']">修改
                    </el-button>
                    <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
                               v-hasPermi="['xjc-platform:studentmanager:remove']">删除
                    </el-button>
                </template>
            </el-table-column>
        </el-table>

        <pagination
                v-show="total>0"
                :total="total"
                v-model:page="queryParams.pageNum"
                v-model:limit="queryParams.pageSize"
                @pagination="getList"
        />

        <!-- 添加或修改学生管理对话框 -->
        <el-dialog :title="title" v-model="open" width="500px" append-to-body>
            <el-form ref="studentmanagerRef" :model="form" :rules="rules" label-width="80px">
                <el-form-item label="学校" prop="officeId">
                    <el-input v-model="form.officeName" placeholder="请选择学校" @click="handleOfficeComponentSelect"/>
                </el-form-item>
                <el-form-item label="年级" prop="gradeYear">
                    <el-select v-model="form.gradeYear" placeholder="请选择年级">
                        <el-option
                                v-for="dict in sys_user_grade"
                                :key="dict.value"
                                :label="dict.label"
                                :value="parseInt(dict.value)"
                        ></el-option>
                    </el-select>
                </el-form-item>

                <el-form-item label="班级 " prop="classid">
                    <el-input v-model="form.className" placeholder="请选择班级 " @click="handleClassComponentSelect"/>
                </el-form-item>
                <el-form-item label="姓名" prop="officeId">
                    <el-input v-model="form.nickName" placeholder="请输入学校"/>
                </el-form-item>
                <el-form-item label="账号" prop="officeId" v-if="form.userId == null">
                    <el-input v-model="form.userName" placeholder="请输入账号"/>
                </el-form-item>
                <el-form-item label="性别" prop="gender">
                    <el-select v-model="form.gender" placeholder="请选择性别">
                        <el-option
                                v-for="dict in sys_user_sex"
                                :key="dict.value"
                                :label="dict.label"
                                :value="dict.value"
                        ></el-option>
                    </el-select>
                </el-form-item>
            </el-form>
            <template #footer>
                <div class="dialog-footer">
                    <el-button type="primary" @click="submitForm">确 定</el-button>
                    <el-button @click="cancel">取 消</el-button>
                </div>
            </template>
            <office-component :isRadio="1" ref="office_component"
                              @onSelected="onOfficeComponentSelect"></office-component>
            <class-component :isRadio="1" ref="class_component" :officeId="data.form.officeId"
                             :gradeYear="data.form.gradeYear"
                             @onSelected="onClassComponentSelect"></class-component>
        </el-dialog>


        <!-- 学生导入对话框 -->
        <el-dialog :title="upload.title" v-model="upload.open" width="400px" append-to-body>
            <el-upload ref="uploadRef" :limit="1" accept=".xlsx, .xls" :headers="upload.headers"
                       :action="upload.url + '?updateSupport=' + upload.updateSupport" :disabled="upload.isUploading"
                       :on-progress="handleFileUploadProgress" :on-success="handleFileSuccess" :auto-upload="false"
                       drag>
                <el-icon class="el-icon--upload">
                    <upload-filled/>
                </el-icon>
                <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
                <template #tip>
                    <div class="el-upload__tip text-center">
                        <div class="el-upload__tip">
                            <el-checkbox v-model="upload.updateSupport"/>
                            是否更新已经存在的用户数据
                        </div>
                        <span>仅允许导入xls、xlsx格式文件。</span>
                        <el-link type="primary" :underline="false" style="font-size: 12px; vertical-align: baseline"
                                 @click="importTemplate">下载模板
                        </el-link>
                    </div>
                </template>
            </el-upload>
            <template #footer>
                <div class="dialog-footer">
                    <el-button type="primary" @click="submitFileForm">确 定</el-button>
                    <el-button @click="upload.open = false">取 消</el-button>
                </div>
            </template>
        </el-dialog>


    </div>
</template>

<script setup name="Studentmanager">
    import {getToken} from "@/utils/auth"
    import {
        listStudentmanager,
        getStudentmanager,
        delStudentmanager,
        addStudentmanager,
        updateStudentmanager
    } from "@/api/xjc-platform/studentmanager"
    import officeComponent from '@/views/xjccomponents/office_component.vue'
    import classComponent from '@/views/xjccomponents/class_component.vue'

    const {proxy} = getCurrentInstance()
    const {sys_user_sex, sys_user_grade} = proxy.useDict('sys_user_sex', 'sys_user_grade')

    const studentmanagerList = ref([])
    const open = ref(false)
    const loading = ref(true)
    const showSearch = ref(true)
    const ids = ref([])
    const single = ref(true)
    const multiple = ref(true)
    const total = ref(0)
    const title = ref("")


    /*** 用户导入参数 */
    const upload = reactive({
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: import.meta.env.VITE_APP_BASE_API + "/xjc-platform/studentmanager/importData"
    })


    const data = reactive({
        form: {},
        queryParams: {
            pageNum: 1,
            pageSize: 10,
            studentnum: null,
            classid: null,
            studentno: null,
            gender: null,
            aliasLoginName: null,
            originalClassid: null,
            userName: null,
            nickName: null
        },
        rules: {}
    })

    const {queryParams, form, rules} = toRefs(data)

    const office_component = ref(null)
    const class_component = ref(null)

    /** 查询学生管理列表 */
    function getList() {
        loading.value = true
        listStudentmanager(queryParams.value).then(response => {
            studentmanagerList.value = response.rows
            total.value = response.total
            loading.value = false
        })
    }

    // 取消按钮
    function cancel() {
        open.value = false
        reset()
    }

    // 表单重置
    function reset() {
        form.value = {
            id: null,
            studentnum: null,
            classid: null,
            studentno: null,
            gender: null,
            aliasLoginName: null,
            delFlag: null,
            updateBy: null,
            updateTime: null,
            createBy: null,
            createTime: null,
            originalClassid: null
        }
        proxy.resetForm("studentmanagerRef")
    }

    /** 搜索按钮操作 */
    function handleQuery() {
        queryParams.value.pageNum = 1
        getList()
    }

    /** 重置按钮操作 */
    function resetQuery() {
        proxy.resetForm("queryRef")
        handleQuery()
    }

    // 多选框选中数据
    function handleSelectionChange(selection) {
        ids.value = selection.map(item => item.id)
        single.value = selection.length != 1
        multiple.value = !selection.length
    }

    /** 新增按钮操作 */
    function handleAdd() {
        reset()
        open.value = true
        title.value = "添加学生管理"
    }

    /** 修改按钮操作 */
    function handleUpdate(row) {
        reset()
        const _id = row.id || ids.value
        getStudentmanager(_id).then(response => {
            form.value = response.data
            open.value = true
            title.value = "修改学生管理"
        })
    }

    /** 提交按钮 */
    function submitForm() {
        proxy.$refs["studentmanagerRef"].validate(valid => {
            if (valid) {
                if (form.value.id != null) {
                    updateStudentmanager(form.value).then(response => {
                        proxy.$modal.msgSuccess("修改成功")
                        open.value = false
                        getList()
                    })
                } else {
                    addStudentmanager(form.value).then(response => {
                        proxy.$modal.msgSuccess("新增成功")
                        open.value = false
                        getList()
                    })
                }
            }
        })
    }

    /** 删除按钮操作 */
    function handleDelete(row) {
        const _ids = row.id || ids.value
        proxy.$modal.confirm('是否确认删除学生管理编号为"' + _ids + '"的数据项？').then(function () {
            return delStudentmanager(_ids)
        }).then(() => {
            getList()
            proxy.$modal.msgSuccess("删除成功")
        }).catch(() => {
        })
    }

    /** 导出按钮操作 */
    function handleExport() {
        proxy.download('xjc-platform/studentmanager/export', {
            ...queryParams.value
        }, `studentmanager_${new Date().getTime()}.xlsx`)
    }

    getList()
    //添加业务
    //显示学校选择器
    function handleOfficeComponentSelect() {
        office_component.value.setIsRadio("1")
        office_component.value.show()
    }

    function onOfficeComponentSelect(row) {
        form.value.officeId = row.id
        form.value.officeName = row.name
        form.value.deptId = row.deptId
    }

    //显示班级选择器

    function handleClassComponentSelect() {
        if (form.value.gradeYear == undefined || form.value.officeId == undefined) {
            proxy.$modal.msgError("请选择学校和年级")
        } else {
            class_component.value.setIsRadio("1")
            class_component.value.setGradeYear(data.form.gradeYear)
            class_component.value.setOfficeId(data.form.officeId)
            class_component.value.getList()
            class_component.value.show()
        }
    }

    function onClassComponentSelect(row) {
        form.value.classid = row.id
        form.value.className = row.name
        form.value.officeId = row.officeId
    }

    /** 导入按钮操作 */
    function handleImport() {
        upload.title = "学生导入"
        upload.open = true
    }
    /** 下载模板操作 */
    function importTemplate() {
        proxy.download("xjc-platform/studentmanager/importTemplate", {}, `studentmanager_template_${new Date().getTime()}.xlsx`)
    }

    /**文件上传中处理 */
    const handleFileUploadProgress = (event, file, fileList) => {
        upload.isUploading = true
    }

    /** 文件上传成功处理 */
    const handleFileSuccess = (response, file, fileList) => {
        upload.open = false
        upload.isUploading = false
        proxy.$refs["uploadRef"].handleRemove(file)
        proxy.$alert("<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" + response.msg + "</div>", "导入结果", {dangerouslyUseHTMLString: true})
        getList()
    }

    /** 提交上传文件 */
    function submitFileForm() {
        proxy.$refs["uploadRef"].submit()
    }


</script>
